// $Modified: Mon Sep 27 13:30:57 2010 by uwer $
#include "GKM.h"
#include <iostream>
#include <complex>

#define ZERO DOUBLE(0.)
#define ONE DOUBLE(1.)
#define TWO DOUBLE(2.)
#define THREE DOUBLE(3.)
#define FOUR DOUBLE(4.)
#define FIVE DOUBLE(5.)
#define SIX DOUBLE(6.)
#define SEVEN DOUBLE(7.)

#define PI DOUBLE(SETVAL(3.14159265358979323846264338327950288419716939937510582097494459230))


using namespace std;

#define SETP(X1,X2,X3,X4) SETVAL(X1),SETVAL(X2),SETVAL(X3),SETVAL(X4)


static void GKMCopy(int n, DOUBLE src[][4], DOUBLE dest[][4]){
  for (int i = 0; i < n; i++){
    for (int mu = 0; mu < 4; mu++){
      dest[i][mu] = src[i][mu];
    }
  }
}

static void GKMCopy(int n, GKM src[], GKM dest[]){
  for(int i=0;i<n;i++){
    dest[i].hel = src[i].hel;
    dest[i].res = src[i].res;
  }
}

void GKMsetmom(const int n, DOUBLE moms[][4], GKM res[]){
  if (n==4) {
    DOUBLE theta = PI/THREE;
    DOUBLE p[4][4] = {
      {SETP(1.,0,0.,1)},
      {SETP(1.,0.,0,-1)},
      {SETVAL(-1.),sin(theta),SETVAL(0.),cos(theta)},
      {SETVAL(-1.),-sin(theta),SETVAL(0.),-cos(theta)}
    };
    GKMCopy(n,p,moms);

    GKM tmp[5] = {
      {"++++",complex<DOUBLE>(0.33333)},
      {"-+++",complex<DOUBLE>(0.7500)},
      {"--++",complex<DOUBLE>(2.75849)},
      {"-+-+",complex<DOUBLE>(2.56959,-3.29626)},
      {"none",complex<DOUBLE>(0.)}
    };
    GKMCopy(5,tmp,res);
  }

  if (n==5) {
    DOUBLE xi=TWO/(ONE+sqrt(TWO)+sqrt(THREE));
    DOUBLE p[5][4] = {
      {SETP(1.,0,0.,1)},
      {SETP(1.,0.,0,-1)},
      {-xi,xi,SETVAL(0.),SETVAL(0.)},
      {-xi*sqrt(TWO),ZERO,xi,xi},
      {SETP(0.,0.,0.,0.)}
    };
    for (int mu = 0; mu<4; mu++){
      p[4][mu] = -p[0][mu] - p[1][mu] - p[2][mu] - p[3][mu];
    }
    GKMCopy(n,p,moms);
      GKM tmp[5] = {
	{"+++++",complex<DOUBLE>(0.01056,-0.6614)},
	{"-++++",complex<DOUBLE>(-0.6773,-0.4976)},
	{"--+++",complex<DOUBLE>(7.58310859,-3.5949778)},
	{"-+-++",complex<DOUBLE>(4.4988481,-6.6910318)},
	{"none",complex<DOUBLE>(0.)}
    };
      GKMCopy(5,tmp,res);
  }
  
  if (n==6) {
    DOUBLE theta=PI/FOUR;
    DOUBLE phi=PI/SIX;
    DOUBLE alpha=PI/THREE;
    DOUBLE NINETEEN=19.0;
    DOUBLE beta=acos(-SEVEN/NINETEEN);
    DOUBLE st=sin(theta);
    DOUBLE ct=cos(theta);
    DOUBLE sp=sin(phi);
    DOUBLE cp=cos(phi);
    DOUBLE sa=sin(alpha);
    DOUBLE ca=cos(alpha);
    DOUBLE sb=sin(beta);
    DOUBLE cb=-SEVEN/NINETEEN;
    
    DOUBLE p[6][4] = {
      {-ONE,ct*sp,ct*cp,st},
      {-ONE,-ct*sp,-ct*cp,-st},
      {ONE,ZERO,ZERO,ONE},
      {ONE,sb,ZERO,cb},
      {ONE,ca*sb,sa,ca*cb},
      {0.,0.,0.,0.}
    };
    for (int mu = 0; mu<4; mu++){
      p[0][mu]=THREE*p[0][mu];
      p[1][mu]=THREE*p[1][mu];
      p[2][mu]=TWO*p[2][mu];
      p[3][mu]=SIX/SEVEN*p[3][mu];
      p[5][mu] = -p[0][mu] - p[1][mu] - p[2][mu] - p[3][mu]- p[4][mu];
    }
    GKMCopy(n,p,moms);
      GKM tmp[9] = {
	{"++++++",complex<DOUBLE>(0.4968861,-0.1838453)},
	{"-+++++",complex<DOUBLE>(1.0182879,3.0968492)},
	{"--++++",complex<DOUBLE>(9.027526,3.639887)},
	{"-+-+++",complex<DOUBLE>(9.164272,1.480930)},
	{"-++-++",complex<DOUBLE>(5.677187,-12.179127)},
	{"---+++",complex<DOUBLE>(17.727073,-1.661354)},
	{"--+-++",complex<DOUBLE>(9.508509,7.869351)},
	{"-+-+-+",complex<DOUBLE>(14.516436,-2.975062)},
	{"none",complex<DOUBLE>(0.)}
    };
      GKMCopy(9,tmp,res);
  }
  
}
